package jobqueue

type ResultStatus int

const (
	ResultStatusSuccess ResultStatus = iota
	ResultStatusFailed
)

type RunGenericResult interface {
	GetStatus() ResultStatus
}

type RunResult[T any] struct {
	Status ResultStatus
	Data   T
}

func (r RunResult[T]) GetStatus() ResultStatus {
	return r.Status
}

type Runnable[T any] interface {
	Run() (RunResult[T], error)
}
